## libdrumstick 1.0.2

=== CMakeLists.txt ===
# MIDI C++ Library
# Copyright (C) 2005-2015 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
# MA 02110-1301, USA

cmake_minimum_required(VERSION 2.8.11)
project(DRUMSTICK)

if(CMAKE_SIZEOF_VOID_P MATCHES "8")
    set(_INIT_LIB_SUFFIX "64")
else()
    set(_INIT_LIB_SUFFIX "")
endif()
set(LIB_SUFFIX ${_INIT_LIB_SUFFIX} CACHE STRING "optional library install directory suffix: 32, 64, none")

set(CMAKE_COLOR_MAKEFILE ON)
#set(CMAKE_VERBOSE_MAKEFILE ON)
set(CMAKE_CXX_VISIBILITY_PRESET hidden)
set(CMAKE_VISIBILITY_INLINES_HIDDEN ON)
set(CMAKE_INCLUDE_CURRENT_DIR TRUE)
set(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/bin)
set(LIBRARY_OUTPUT_PATH ${PROJECT_BINARY_DIR}/lib)

# Additional CMake modules for 3rd party library checks reside here
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake_admin")

# DRUMSTICK version string
set(VERSION_MAJOR "1")
set(VERSION_MINOR "0")
set(VERSION_PATCH "2")
set(VERSION_SUFFIX "")
set(VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}${VERSION_SUFFIX})
add_definitions(-DVERSION=${VERSION})

message(STATUS "drumstick ${VERSION} prefix: ${CMAKE_INSTALL_PREFIX}")

set(_DBUS_INIT OFF)
if(${CMAKE_SYSTEM} MATCHES "Linux")
	set(_DBUS_INIT ON)
endif()

# User options
option(STATIC_DRUMSTICK "Build static libraries instead of dynamic" OFF)
option(USE_DBUS "Include DBus support (required for RealtimeKit)" ${_DBUS_INIT})

message(STATUS "Build configuration: ${CMAKE_BUILD_TYPE}")

if(STATIC_DRUMSTICK)
    set(BUILD_SHARED_LIBS OFF)
    add_definitions(-DDRUMSTICK_STATIC)
    message(STATUS "Building static libraries")
else()
    set(BUILD_SHARED_LIBS ON)
    message(STATUS "Building dynamic libraries")
endif()

find_package(Qt5Core REQUIRED)
message(STATUS "Found Qt5 version = ${Qt5Core_VERSION_STRING}")

if(USE_DBUS)
    find_package(Qt5DBus REQUIRED)
    add_definitions(-DRTKIT_SUPPORT)
endif()

find_package(PkgConfig REQUIRED)
if(PKG_CONFIG_FOUND)
    message(STATUS "Program pkg-config found (${PKG_CONFIG_EXECUTABLE})")
else()
    message(FATAL_ERROR "Program pkg-config not found")
endif()

if(${CMAKE_SYSTEM} MATCHES "Linux")
    pkg_check_modules(ALSA alsa>=1.0.0)
    if(ALSA_FOUND)
        set(ALSA_LIBS ${ALSA_LIBRARIES})
        list(APPEND ALSA_LIB_DIR ${ALSA_LIBRARY_DIRS} ${ALSA_LIBDIR})
        list(APPEND ALSA_INC_DIR ${ALSA_INCLUDE_DIRS} ${ALSA_INCLUDEDIR})
    else()
        message(STATUS "Warning: ALSA library not found.")
    endif()
endif()

link_directories(${DRUMSTICK_BINARY_DIR}/lib)
include_directories( BEFORE
    ${DRUMSTICK_SOURCE_DIR}/library
    ${DRUMSTICK_SOURCE_DIR}/library/include)

add_subdirectory(library)
add_subdirectory(utils)
add_subdirectory(icons)

if(${CMAKE_SYSTEM} MATCHES "Linux")
    find_package(Doxygen)
    if(DOXYGEN_FOUND)
        configure_file(
            "${CMAKE_SOURCE_DIR}/Doxyfile.in"
            "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile"
            IMMEDIATE @ONLY)
        add_custom_target(doxygen
            ${DOXYGEN} Doxyfile
            WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
    endif()
    add_subdirectory(doc)
    configure_file(drumstick-alsa.pc.in drumstick-alsa.pc IMMEDIATE @ONLY)
    configure_file(drumstick.spec.in drumstick.spec IMMEDIATE @ONLY)
    install(FILES
	${CMAKE_CURRENT_BINARY_DIR}/drumstick-alsa.pc
	DESTINATION lib${LIB_SUFFIX}/pkgconfig )
    # XML mime types
    set( SHARED_MIME_INFO_MINIMUM_VERSION "0.30" )
    set( XDG_MIME_INSTALL_DIR "share/mime/packages" )
    find_package( SharedMimeInfo )
    if( SHARED_MIME_INFO_FOUND )
        install( FILES drumstick.xml DESTINATION ${XDG_MIME_INSTALL_DIR} )
        update_xdg_mimetypes( ${XDG_MIME_INSTALL_DIR} )
    endif()
endif()

configure_file(drumstick-file.pc.in drumstick-file.pc IMMEDIATE @ONLY)
install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/drumstick-file.pc
    DESTINATION lib${LIB_SUFFIX}/pkgconfig )

configure_file(drumstick-rt.pc.in drumstick-rt.pc IMMEDIATE @ONLY)
install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/drumstick-rt.pc
    DESTINATION lib${LIB_SUFFIX}/pkgconfig )

# uninstall custom target
configure_file(
    "${CMAKE_SOURCE_DIR}/cmake_admin/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)

add_custom_target( uninstall
    "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

if(${CMAKE_SYSTEM} MATCHES "Linux")
    # tarball target
    add_custom_target( tarball
        COMMAND mkdir -p drumstick-${VERSION}
        COMMAND cp -r cmake_admin drumstick-${VERSION}
        COMMAND cp -r library drumstick-${VERSION}
        COMMAND cp -r utils drumstick-${VERSION}
        COMMAND cp -r doc drumstick-${VERSION}
        COMMAND cp -r icons drumstick-${VERSION}
        COMMAND cp CMakeLists.txt AUTHORS COPYING ChangeLog INSTALL NEWS README TODO drumstick*.in drumstick.pro drumstick.xml configure* Doxyfile.in chkcoverage global.pri drumstick-${VERSION}
        COMMAND tar -cj --exclude=.[a-z]* -f drumstick-${VERSION}.tar.bz2 drumstick-${VERSION}
        COMMAND tar -cz --exclude=.[a-z]* -f drumstick-${VERSION}.tar.gz  drumstick-${VERSION}
        COMMAND zip -qr drumstick-${VERSION}.zip drumstick-${VERSION} -x '.[a-z]*'
        COMMAND rm -rf drumstick-${VERSION}
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    )
endif()

=== doc/CMakeLists.txt ===
# MIDI Sequencer C++ Library 
# Copyright (C) 2008-2015 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along 
# with this program; If not, see <http://www.gnu.org/licenses/>.

FIND_PROGRAM(XSLTPROC_EXECUTABLE xsltproc)
IF(XSLTPROC_EXECUTABLE)
    MESSAGE(STATUS "XSLTPROC Found: ${XSLTPROC_EXECUTABLE}")
    CONFIGURE_FILE(drumstick-buildsmf.xml.in 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-buildsmf.xml IMMEDIATE @ONLY)
    CONFIGURE_FILE(drumstick-drumgrid.xml.in 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-drumgrid.xml IMMEDIATE @ONLY)
    CONFIGURE_FILE(drumstick-dumpmid.xml.in 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-dumpmid.xml IMMEDIATE @ONLY)
    CONFIGURE_FILE(drumstick-dumpove.xml.in 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-dumpove.xml IMMEDIATE @ONLY)
    CONFIGURE_FILE(drumstick-dumpsmf.xml.in 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-dumpsmf.xml IMMEDIATE @ONLY)
    CONFIGURE_FILE(drumstick-dumpwrk.xml.in 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-dumpwrk.xml IMMEDIATE @ONLY)
    CONFIGURE_FILE(drumstick-metronome.xml.in 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-metronome.xml IMMEDIATE @ONLY)
    CONFIGURE_FILE(drumstick-playsmf.xml.in 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-playsmf.xml IMMEDIATE @ONLY)
    CONFIGURE_FILE(drumstick-guiplayer.xml.in 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-guiplayer.xml IMMEDIATE @ONLY)
    CONFIGURE_FILE(drumstick-sysinfo.xml.in 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-sysinfo.xml IMMEDIATE @ONLY)
    CONFIGURE_FILE(drumstick-vpiano.xml.in 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-vpiano.xml IMMEDIATE @ONLY)
    INCLUDE(CreateManpages)
    CREATE_MANPAGES ( 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-buildsmf.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-drumgrid.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-dumpmid.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-dumpove.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-dumpsmf.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-dumpwrk.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-metronome.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-playsmf.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-guiplayer.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-sysinfo.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-vpiano.xml 
    )
ELSE(XSLTPROC_EXECUTABLE)
    MESSAGE(STATUS "Warning: XSLTPROC NOT Found. Man pages won't be installed")
ENDIF(XSLTPROC_EXECUTABLE)

=== library/CMakeLists.txt ===
# MIDI Sequencer C++ Library
# Copyright (C) 2005-2015 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
# MA 02110-1301, USA

if(ALSA_FOUND)
    add_subdirectory(alsa)
endif()
add_subdirectory(file)
add_subdirectory(rt)
add_subdirectory(rt-backends)

=== utils/CMakeLists.txt ===
# MIDI Sequencer C++ Library
# Copyright (C) 2005-2015 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
# MA 02110-1301, USA

include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/common
    ${CMAKE_CURRENT_BINARY_DIR}/common
)

add_subdirectory(common)
add_subdirectory(buildsmf)
add_subdirectory(dumpsmf)
add_subdirectory(dumpwrk)
add_subdirectory(dumpove)
add_subdirectory(test-rt)
add_subdirectory(vpiano)

if(ALSA_FOUND)
    add_subdirectory(dumpmid)
    add_subdirectory(playsmf)
    add_subdirectory(guiplayer)
    add_subdirectory(sysinfo)
    add_subdirectory(testevents)
    add_subdirectory(timertest)
    add_subdirectory(metronome)
    add_subdirectory(drumgrid)
endif()

=== library/alsa/CMakeLists.txt ===
# MIDI Sequencer C++ Library
# Copyright (C) 2005-2015 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
# MA 02110-1301, USA

set(CMAKE_INCLUDE_CURRENT_DIR ON)
include_directories(${ALSA_INC_DIR})
link_directories(${ALSA_LIB_DIR})

set(drumstick-alsa_QTOBJ_SRCS
    ../include/alsaclient.h
    ../include/alsaevent.h
    ../include/alsaport.h
    ../include/alsaqueue.h
    ../include/alsatimer.h
    ../include/playthread.h
)

set(drumstick-alsa_HEADERS
    ../include/alsaclient.h
    ../include/alsaevent.h
    ../include/alsaport.h
    ../include/alsaqueue.h
    ../include/alsatimer.h
    ../include/drumstickcommon.h
    ../include/playthread.h
    ../include/subscription.h
)

SET(drumstick-alsa_SRCS
    alsaclient.cpp
    alsaevent.cpp
    alsaport.cpp
    alsaqueue.cpp
    alsatimer.cpp
    playthread.cpp
    subscription.cpp
)


qt5_wrap_cpp(drumstick-alsa_MOC_SRCS ${drumstick-alsa_QTOBJ_SRCS})

add_library(drumstick-alsa
    ${drumstick-alsa_MOC_SRCS}
    ${drumstick-alsa_SRCS}
    ${drumstick-alsa_HEADERS}
)

target_link_libraries(drumstick-alsa
    ${ALSA_LIBS}
    Qt5::Core
    Qt5::DBus
)

if(STATIC_DRUMSTICK)
    set_target_properties(drumstick-alsa PROPERTIES
         STATIC_LIB "libdrumstick-alsa")
else()
    set_target_properties(drumstick-alsa PROPERTIES
        VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}
        SOVERSION ${VERSION_MAJOR}
    )
endif()

install(TARGETS drumstick-alsa
        RUNTIME DESTINATION bin
        ARCHIVE DESTINATION lib${LIB_SUFFIX}
        LIBRARY DESTINATION lib${LIB_SUFFIX})
install(FILES ${drumstick-alsa_HEADERS}
        DESTINATION include/drumstick)
install(FILES ../include/drumstick.h
        DESTINATION include)

=== library/file/CMakeLists.txt ===
# MIDI Sequencer C++ Library
# Copyright (C) 2005-2015 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
# MA 02110-1301, USA

set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(drumstick-file_QTOBJ_SRCS
    ../include/qsmf.h
    ../include/qwrk.h
    ../include/qove.h
)

set(drumstick-file_HEADERS
    ../include/macros.h
    ../include/qsmf.h
    ../include/qwrk.h
    ../include/qove.h
)

set(drumstick-file_SRCS
    qsmf.cpp
    qwrk.cpp
    qove.cpp
)

qt5_wrap_cpp(drumstick-file_MOC_SRCS ${drumstick-file_QTOBJ_SRCS})

add_library(drumstick-file
    ${drumstick-file_MOC_SRCS}
    ${drumstick-file_SRCS} 
    ${drumstick-file_HEADERS} 
)

target_link_libraries(drumstick-file Qt5::Core)

if(STATIC_DRUMSTICK)
    set_target_properties(drumstick-file PROPERTIES
        STATIC_LIB "libdrumstick-file")
else()
    set_target_properties(drumstick-file PROPERTIES
        VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}
        SOVERSION ${VERSION_MAJOR})
endif()

install(TARGETS drumstick-file
	RUNTIME DESTINATION bin
	ARCHIVE DESTINATION lib${LIB_SUFFIX}
	LIBRARY DESTINATION lib${LIB_SUFFIX})

install(FILES ${drumstick-file_HEADERS}
        DESTINATION include/drumstick)

=== library/rt-backends/CMakeLists.txt ===
# MIDI Sequencer C++ Library
# Copyright (C) 2005-2015 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
# MA 02110-1301, USA

#add_subdirectory(dummy-in)
#add_subdirectory(dummy-out)

if(ALSA_FOUND)
    add_subdirectory(alsa-in)
    add_subdirectory(alsa-out)
endif()

find_package(Qt5Network)
if(Qt5Network_FOUND)
    add_subdirectory(net-in)
    add_subdirectory(net-out)
endif()

if(UNIX AND NOT APPLE)
    add_subdirectory(oss-in)
    add_subdirectory(oss-out)
endif()

if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    add_subdirectory(mac-in)
    add_subdirectory(mac-out)
endif()

if(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
    add_subdirectory(win-in)
    add_subdirectory(win-out)
endif()

pkg_check_modules(FLUIDSYNTH fluidsynth>=1.1.1)
if(FLUIDSYNTH_FOUND)
    add_subdirectory(synth)
endif()

=== library/rt/CMakeLists.txt ===
# MIDI Sequencer C++ Library
# Copyright (C) 2005-2015 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
# MA 02110-1301, USA

set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(drumstick-rt_QOBJ_SRCS
    ../include/rtmidiinput.h
    ../include/rtmidioutput.h
)

set(drumstick-rt_HEADERS
	../include/macros.h
    ../include/rtmidiinput.h
    ../include/rtmidioutput.h
    ../include/backendmanager.h
)

set(drumstick-rt_SRCS
    backendmanager.cpp
)
    
qt5_wrap_cpp(drumstick-rt_MOC_SRCS ${drumstick-rt_QOBJ_SRCS})

add_library(drumstick-rt
    ${drumstick-rt_MOC_SRCS}
    ${drumstick-rt_SRCS}
    ${drumstick-rt_HEADERS}
)

target_link_libraries(drumstick-rt Qt5::Core)

if(STATIC_DRUMSTICK)
    set_target_properties(drumstick-rt PROPERTIES
        STATIC_LIB "libdrumstick-rt")
    #
    #    add_definitions(-DDUMMY_BACKEND)
    #    target_link_libraries(drumstick-rt-dummy-in)
    #    target_link_libraries(drumstick-rt-dummy-out)
    #

    if(ALSA_FOUND)
        add_definitions(-DALSA_BACKEND)
        target_link_libraries(drumstick-rt
            drumstick-rt-alsa-in
            drumstick-rt-alsa-out
            drumstick-alsa)
    endif()

    if(UNIX AND NOT APPLE)
        add_definitions(-DOSS_BACKEND)
        target_link_libraries(drumstick-rt
            drumstick-rt-oss-in
            drumstick-rt-oss-out)
    endif()


    if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
        add_definitions(-DMAC_BACKEND)
        target_link_libraries(drumstick-rt
            drumstick-rt-mac-in
            drumstick-rt-mac-out
            "-framework CoreMidi -framework CoreFoundation")
    endif()


    if(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
        add_definitions(-DWIN_BACKEND)
        target_link_libraries(drumstick-rt
            drumstick-rt-win-in
            drumstick-rt-win-out
            winmm)
    endif()


    find_package(Qt5Network)
    if(Qt5Network_FOUND)
        add_definitions(-DNET_BACKEND)
        target_link_libraries(drumstick-rt
            drumstick-rt-net-in
            drumstick-rt-net-out)
    endif()

    pkg_check_modules(FLUIDSYNTH fluidsynth>=1.1.1)
    if(FLUIDSYNTH_FOUND)
        add_definitions(-DSYNTH_BACKEND)
        target_link_libraries(drumstick-rt drumstick-rt-synth)
    endif()

else() # STATIC_DRUMSTICK

    set_target_properties(drumstick-rt PROPERTIES
        VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}
        SOVERSION ${VERSION_MAJOR})
endif()

install(TARGETS drumstick-rt
	RUNTIME DESTINATION bin
	ARCHIVE DESTINATION lib${LIB_SUFFIX}
	LIBRARY DESTINATION lib${LIB_SUFFIX})

install(FILES ${drumstick-rt_HEADERS}
        DESTINATION include/drumstick)

=== utils/buildsmf/CMakeLists.txt ===
# MIDI Sequencer C++ Library
# Copyright (C) 2005-2015 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
# MA 02110-1301, USA

SET(buildsmf_SRCS
    buildsmf.cpp
    buildsmf.h
)

SET(buildsmf_qtobject_SRCS
    buildsmf.h
)

QT5_WRAP_CPP(buildsmf_moc_SRCS ${buildsmf_qtobject_SRCS})

ADD_EXECUTABLE(drumstick-buildsmf 
    ${buildsmf_moc_SRCS}
    ${buildsmf_SRCS}
)

TARGET_LINK_LIBRARIES(drumstick-buildsmf
    drumstick-common
    drumstick-file
    Qt5::Core
)

INSTALL(TARGETS drumstick-buildsmf 
        RUNTIME DESTINATION bin)

=== utils/common/CMakeLists.txt ===
# MIDI Sequencer C++ Library
# Copyright (C) 2005-2015 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
# MA 02110-1301, USA

set( common_SRCS
    cmdlineargs.cpp
    cmdlineargs.h
    cmdversion.h
)

add_library( drumstick-common STATIC
    ${common_SRCS})

target_link_libraries(drumstick-common Qt5::Core)

=== utils/drumgrid/CMakeLists.txt ===
# MIDI Sequencer C++ Library
# Copyright (C) 2005-2015 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
# MA 02110-1301, USA

find_package(Qt5Widgets REQUIRED)

set(drumgrid_forms_SRCS
    drumgridabout.ui
    drumgrid.ui
)

set(drumgrid_SRCS
    drumgridabout.cpp
    drumgridabout.h
    drumgrid.cpp
    drumgrid.h
    drumgridmodel.cpp
    drumgridmodel.h
    drumgridmain.cpp
)

set(drumgrid_qtobject_SRCS
    drumgridabout.h
    drumgridmodel.h
    drumgrid.h
)

QT5_WRAP_UI(drumgrid_ui_SRCS ${drumgrid_forms_SRCS})

QT5_WRAP_CPP(drumgrid_moc_SRCS ${drumgrid_qtobject_SRCS})

ADD_EXECUTABLE(drumstick-drumgrid
    ${drumgrid_ui_SRCS}
    ${drumgrid_moc_SRCS}
    ${drumgrid_SRCS}
)

TARGET_LINK_LIBRARIES(drumstick-drumgrid
    ${ALSA_LIBS} 
    drumstick-common
    drumstick-alsa
    Qt5::Widgets
)

INSTALL(TARGETS drumstick-drumgrid 
        RUNTIME DESTINATION bin)

INSTALL(FILES drumstick-drumgrid.desktop
        DESTINATION share/applications)

=== utils/dumpmid/CMakeLists.txt ===
# MIDI Sequencer C++ Library
# Copyright (C) 2005-2015 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
# MA 02110-1301, USA

SET(dumpmid_SRCS
    dumpmid.cpp
    dumpmid.h
)

SET(dumpmid_qtobject_SRCS
    dumpmid.h
)

QT5_WRAP_CPP(dumpmid_moc_SRCS ${dumpmid_qtobject_SRCS})

ADD_EXECUTABLE(drumstick-dumpmid
    ${dumpmid_moc_SRCS}
    ${dumpmid_SRCS}
)

TARGET_LINK_LIBRARIES(drumstick-dumpmid
    ${ALSA_LIBS} 
    drumstick-common
    drumstick-alsa
    Qt5::Core
)

# we should install some files...
INSTALL(TARGETS drumstick-dumpmid 
        RUNTIME DESTINATION bin)

=== debian/changelog ===
libdrumstick (1.0.2-1) experimental; urgency=medium

  [ Alessio Treglia ]
  * New upstream version (Closes: #824771)

  [ Ross Gammon ]
  * Add myself to uploaders
  * Update copyright years
  * Update to Qt5 dependencies from Qt4
  * Extend gcc6 patch for new upstream version
  * Patch desktop file Exec key with %f
  * Patch desktop files to provide keyword entries
  * Rename library package due to SONAME bump
  * Update lintian-override according to updated package name
  * Add bindnow hardening option

 -- Ross Gammon <rosco2@ubuntu.com>  Fri, 26 Aug 2016 22:09:28 +0200

libdrumstick (0.5.0-4) unstable; urgency=medium

  * Team upload.
  * debian/control:
    - Build-depend on debhelper 9.
    - Build-depend on docbook-xml to prevent network access during the build.
    - Drop build-dependency on autotools-dev.
    - Remove obsolete DM-Upload-Allowed field.
    - Use canonical Vcs urls.
    - Remove libdrumstick-dbg in favour of dbysym packages.
    - Bump standards to 3.9.8.
  * debian/patches:
    - Fix FTBFS with GCC 6. (Closes: #811736)
    - Drop multiarch patches and use LIB_SUFFIX directly.
  * debian/shlibs.local:
    - Remove unused shlibs.local file.

 -- James Cowgill <jcowgill@debian.org>  Sat, 23 Jul 2016 14:10:10 +0100

=== debian/control ===
Source: libdrumstick
Section: libs
Priority: optional
Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders:
 Alessio Treglia <alessio@debian.org>,
 Adrian Knoth <adi@drcomp.erfurt.thur.de>,
 Arnout Engelen <arnouten@bzzt.net>,
 Ross Gammon <rosco2@ubuntu.com>
Build-Depends:
 cmake,
 debhelper (>= 9),
 docbook-xml,
 docbook-xsl,
 libasound2-dev,
 libqt5svg5-dev,
 qtbase5-dev,
 libx11-dev,
 pkg-config,
 xsltproc
Standards-Version: 3.9.8
Homepage: http://drumstick.sourceforge.net/
Vcs-Git: https://anonscm.debian.org/git/pkg-multimedia/libdrumstick.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-multimedia/libdrumstick.git

Package: libdrumstick-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libdrumstick1 (= ${binary:Version}),
 ${misc:Depends}
Description: Qt4/C++ wrapper for ALSA Sequencer - development files
 This library is a C++ wrapper around the ALSA library sequencer interface,
 using Qt4 objects, idioms and style. ALSA sequencer provides software support
 for MIDI technology on Linux. Complementary classes for SMF and WRK file
 processing are also included.
 .
 This package provides the development files.

Package: libdrumstick1
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: Qt4/C++ wrapper for ALSA Sequencer
 This library is a C++ wrapper around the ALSA library sequencer interface,
 using Qt4 objects, idioms and style. ALSA sequencer provides software support
 for MIDI technology on Linux. Complementary classes for SMF and WRK file
 processing are also included.

Package: drumstick-tools
Section: sound
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: Qt4/C++ wrapper for ALSA Sequencer - utilities
 This library is a C++ wrapper around the ALSA library sequencer interface,
 using Qt4 objects, idioms and style. ALSA sequencer provides software support
 for MIDI technology on Linux. Complementary classes for SMF and WRK file
 processing are also included.
 .
 This package provides utilities shipped with the library:
  - drumstick-buildsmf: Standard MIDI File creation from scratch.
  - drumstick-dumpgrid: Simple Qt drum sequencer.
  - drumstick-dumpmid: Write ALSA MIDI events to STDOUT.
  - drumstick-dumpsmf: Write MIDI events from a MIDI file to STDOUT.
  - drumstick-dumpwrk: Write MIDI events from a Cakewalk WRK file to STDOUT.
  - drumstick-guiplayer: Simple Qt MIDI file player.
  - drumstick-metronome: Headless MIDI metronome.
  - drumstick-playsmf: Headless MIDI file player.
  - drumstick-sysinfo: Display information about ALSA MIDI.
  - drumstick-timertest: Test performance of the ALSA timer.
  - drumstick-vpiano: Virtual Piano Keyboard GUI application.

=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LDFLAGS+=-Wl,--as-needed
export DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow

%:
	dh $@ -S cmake

override_dh_auto_configure:
	dh_auto_configure -- -DLIB_SUFFIX=/$(DEB_HOST_MULTIARCH)

override_dh_strip:
	dh_strip --dbgsym-migration='libdrumstick-dbg (<< 0.5.0-4~)'
